// this class create drill points that in additive form simulates
// a black and white pictures flat fabricated form where blacks remains and 
// whites removed


class UserClass4 implements subfabricator {
  
  private HashSet<CNCOneLayerData> COLData = new HashSet<CNCOneLayerData>();
  private HashSet<CNCOneLayerData> COLDataAdd = new HashSet<CNCOneLayerData>();
  private HashSet<CNCOneLayerData> COLDataRemove = new HashSet<CNCOneLayerData>();
  private HashSet<CNCMltLayerData> CMLData = new HashSet<CNCMltLayerData>();
  private HashSet<CNCMltLayerData> CMLDataAdd = new HashSet<CNCMltLayerData>();
  private HashSet<CNCMltLayerData> CMLDataRemove = new HashSet<CNCMltLayerData>();
  private HashSet<RBTOneLayerData> ROLData = new HashSet<RBTOneLayerData>();
  private HashSet<RBTOneLayerData> ROLDataAdd = new HashSet<RBTOneLayerData>();
  private HashSet<RBTOneLayerData> ROLDataRemove = new HashSet<RBTOneLayerData>();
  private HashSet<RBTMltLayerData> RMLData = new HashSet<RBTMltLayerData>();
  private HashSet<RBTMltLayerData> RMLDataAdd = new HashSet<RBTMltLayerData>();
  private HashSet<RBTMltLayerData> RMLDataRemove = new HashSet<RBTMltLayerData>();
  private int numInXDir;
  private int numInYDir;
  private float stepSize;
  private PImage img;
  
  UserClass4() {
    img = loadImage("C:\\temp\\images\\dla1.JPG");
    this.numInXDir = img.width;
    this.numInYDir = img.height;
    this.stepSize = 1;
    int cols = floor(this.numInXDir / stepSize);
    int rows = floor(this.numInYDir / stepSize);
    for (int i = 0; i < cols; i++) {
      for (int j = 0; j < rows; j++) {
        int loc = floor(i + j * numInXDir);           // Pixel array location       
        color c = img.pixels[loc];       // Grab the color
        // Calculate a z position as a function of mouseX and pixel brightness
        float magnitude = 0;
        if (brightness(img.pixels[loc]) > 200) {
          magnitude = 10;
        }   
        if (brightness(img.pixels[loc]) <= 200) {
          magnitude = 0;
        }       
        //PVector position = new PVector(x, y, 20); 
        PVector position = new PVector(i, j, 10); 
        float diameter = 1;
        CNCOneLayerData curData = new CNCOneLayerData(position, magnitude, diameter);
        COLData.add(curData);

      }
    }
  }
  
  void doUpdate() {
  }
  
  int getNumInXDir() {
    return this.numInXDir;
  }
  
  int getNumInYDir() {
    return this.numInYDir;
  }
  
  float getStepSize() {
    return this.stepSize;
  }
  
  HashSet<CNCOneLayerData> CNCOneLayer() {
    return COLData;
  }
  
  HashSet<CNCOneLayerData> AddToCNCOneLayer() {
    return COLDataAdd;
  }
  
  HashSet<CNCOneLayerData> RemoveFromCNCOneLayer() {
    return COLDataRemove;
  }
  
  HashSet<CNCMltLayerData> CNCMltLayer() {
    return CMLData;
  }
  
  HashSet<CNCMltLayerData> AddToCNCMltLayer() {
    return CMLDataAdd;
  }
  
  HashSet<CNCMltLayerData> RemoveFromCNCMltLayer() {
    return CMLDataRemove;
  }
  
  HashSet<RBTOneLayerData> RBTOneLayer() {
    return ROLData;
  }
  
  HashSet<RBTOneLayerData> AddToRBTOneLayer() {
    return ROLDataAdd;
  }
  
  HashSet<RBTOneLayerData> RemoveFromRBTOneLayer() {
    return ROLDataRemove;
  }
  
  HashSet<RBTMltLayerData> RBTMltLayer() {
    return RMLData;
  }
  
  HashSet<RBTMltLayerData> AddToRBTMltLayer() {
    return RMLDataAdd;
  }
  
  HashSet<RBTMltLayerData> RemoveFromRBTMltLayer() {
    return RMLDataRemove;
  }
  
}
